  /******************************************************************************
  * @Example PT32X005_Analog_Channel
  * @author  ӦÿŶ
  * @version V1.1.0
  * @date    2020/1/27
  * @brief   ͨADCɼڲοѹ3.3VΪ׼һʱӡһADCתĵѹ
  *          
  ******************************************************************************
  * @attention	Ϊ384001λֹͣλУ
  *				ʹø̣
  *						ҪJ20RXPD5̽ӣTXPD6̽
  *						ṩ4ADCͨòο˶4궨塰Sample_xxx,Ӧĺ궨ֵΪ1жӦĹ
  *						Sample_CH0Ϊ1ʱҪJ19ADC0ֶ̽ӣɵ軬ŵѹADC
  *
  *****************************************************************************/
	
#include "PT32X005.h"

#define Sample_CH0		0
#define Sample_BG1v5	0
#define Sample_BG1v0	0
#define Sample_BG1v2	1

void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<100; i++)
		for(j=0; j<100; j++)
			for(x=0; x<100; x++);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_5, AFIO_AF_0,ENABLE);	//RXֹܸ
	GPIO_DigRemapConfig(AFIOD, AFIO_Pin_6, AFIO_AF_0,ENABLE);	//TXֹܸ
}

/**
* @brief ʼUARTģĹ乤ʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;						//һUART_InitTypeDef͵Ľṹ
	
	UART_StructInit(&UART_InitStruct);						//ʹĬֵʼUART_InitStruct
	
	UART_InitStruct.UART_BaudRate = 38400;					//ò 
	UART_InitStruct.UART_WordLength = UART_WP_8D;			//λ
	UART_InitStruct.UART_StopBits = UART_STOP_1b;			//ֹͣλ
	UART_InitStruct.UART_Parity = UART_PS_EVEN;				//Уλ
	UART_InitStruct.UART_Mode = UART_RE_Enable;				//RXʹ
	UART_InitStruct.UART_LoopBack=UART_LoopBack_Disable;	//عر
	
	UART_Init(UART0, &UART_InitStruct);						//ʼUART

	UART_Cmd(UART0, ENABLE);								//ʹUART
}

/**
* @brief UARTģ
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief ADC
* @param 
* @retval 
*/
void ADC_GPIO_Config(void)
{
	GPIO_AnaRemapConfig(AFIOA, GPIO_Pin_2, ENABLE);			//ADC_IN0ģ⹦ܸ
}

/**
* @brief ʼADCģĹ乤ʽ
* @param 
* @retval 
*/
void ADC_Mode_Config(void)
{
	ADC_InitTypeDef  ADC_InitStruct;						//һADC_InitTypeDef͵Ľṹ
	
	ADC_StructInit(&ADC_InitStruct);						//ʹĬֵʼADC_InitStruct
	
	#if Sample_BG1v0
	ADC_InitStruct.ADC_BGS_SEL=ADC_BGS_BG1v0;
	#endif
	
	#if Sample_BG1v2
	ADC_InitStruct.ADC_BGS_SEL=ADC_BGS_BG1v2;
	#endif
	
	ADC_Init(ADC, &ADC_InitStruct);							//ʼADC
	
	ADC_SetSampleTime(ADC, 128);							//ADCʱ
	ADC_ChannelConfig(ADC, ADC_CR_CHS_0);					//ADCתͨ0
	ADC_Cmd(ADC, ENABLE);									//ADC蹦
	while(!ADC_GetFlagStatus(ADC, ADC_FLAG_ADRDY));			//ȴADC
}

/**
* @brief ADCģ
* @param 
* @retval 
*/
void ADC_Driver(void)
{	
	ADC_GPIO_Config();
	ADC_Mode_Config();
}


u16 Inter_adcValue = 0;
float temp;
float Volt_Read = 0.0;

int main (void)
{
	UART_Driver();
	ADC_Driver();
	ADC_Cmd(ADC, ENABLE);									//ADC蹦
	while(!ADC_GetFlagStatus(ADC, ADC_FLAG_ADRDY));			//ȴADC
	while(1)
	{
		
	#if Sample_CH0
		ADC_ChannelConfig(ADC, ADC_CR_CHS_0);				//ⲿADCͨ0
	#endif
		
	#if Sample_BG1v5		
		ADC_ChannelConfig(ADC, ADC_CR_CHS_9);				//ڲ1.5Vοѹ
	#endif
		
	#if Sample_BG1v0		
		ADC_Mode_Config();
		ADC_ChannelConfig(ADC, ADC_CR_CHS_8);				//ڲ1.0Vοѹ
	#endif
		
	#if Sample_BG1v2	
		ADC_Mode_Config();
		ADC_ChannelConfig(ADC, ADC_CR_CHS_8);				//ڲ1.2Vοѹ
	#endif
		
		Software_Delay();
		ADC_ConversionConfig(ADC,ENABLE);					//ת
		while(!ADC_GetFlagStatus(ADC, ADC_FLAG_EOC));		//ȴADC
		Inter_adcValue = ADC_GetConversionValue(ADC);		//ȡ
		
		temp = Inter_adcValue;
		temp = (temp / 4096);
		temp *= 3.3;
		Volt_Read = temp;
		printf("ѹ:%f\r\n",Volt_Read);
			
	}
}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


