/**
  ******************************************************************************
  * @file    system_PT32X005.c
  * @author  ӦÿŶ
  * @version V1.1.0
  * @date    2022/2/10
  * @brief   
  ******************************************************************************
  * @attention
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  */



#include "PT32X005.h"

void Wait_ClockReady(void)
{//not modify the delay param...
	volatile int delay;
	for (delay = 0; delay < 10000; delay++);
}

//<<< Use Configuration Wizard in Context Menu >>>

/*--------------------- ʱ ----------------------------------
//
//    <h> ڲRCHSI24M
//      <q0>    ʹ
//                <i> Ĭֵʹ
//    </h>
//    <h> PLLʱ
//      <e2>    ʹ
//                <i> Ĭֵʹ
//        <o3>  PLLʱԴ
//                <0=> HSI
//                <1=> LSI
//                <i> ĬϱƵʱԴHSI
//      </e>
//    </h>
//    <h> ϵͳʱ (SYS_CLK)
//      <o4>    ϵͳʱԴ
//                <0=> HSI
//                <2=> PLLʱ
//                <3=> LSI
//                <i> ĬϵͳʱԴHSI
//      <o5>    HCLKƵ
//                <0=> 0
//                <1=> 1
//                <2=> 2
//                <3=> 3
//                <4=> 4
//                <5=> 5
//                <6=> 6
//                <7=> 7
//                <8=> 8
//                <9=> 9
//                <10=> 10
//                <11=> 11
//                <12=> 12
//                <13=> 13
//                <14=> 14
//                <15=> 15
//                <16=> 16
//                <17=> 17
//                <18=> 18
//                <19=> 19
//                <20=> 20
//                <21=> 21
//                <22=> 22
//                <23=> 23
//                <24=> 24
//                <25=> 25
//                <26=> 26
//                <27=> 27
//                <28=> 28
//                <29=> 29
//                <30=> 30
//                <31=> 31
//                <i> ĬϵͳʱԴƵ0
//      <o6>    PCLK Ƶ
//                <0=> 0
//                <1=> 1
//                <2=> 2
//                <3=> 3
//                <4=> 4
//                <5=> 5
//                <6=> 6
//                <7=> 7
//                <8=> 8
//                <9=> 9
//                <10=> 10
//                <11=> 11
//                <12=> 12
//                <13=> 13
//                <14=> 14
//                <15=> 15
//                <16=> 16
//                <17=> 17
//                <18=> 18
//                <19=> 19
//                <20=> 20
//                <21=> 21
//                <22=> 22
//                <23=> 23
//                <24=> 24
//                <25=> 25
//                <26=> 26
//                <27=> 27
//                <28=> 28
//                <29=> 29
//                <30=> 30
//                <31=> 31
//                <i> ĬPCLKƵ0
//    </h>
//
//    <h> FLASH 
//      <o7>   Flash ȡָȴ
//                <0=> 0 WS
//                <1=> 1 WS
//                <i>  0 WS:  1 KHz <= HCLK <= 24 MHz
//                <i>  1 WS: 24 MHz <  HCLK <= 48 MHz
//    </h>
//
//    <h> MCO
//      <e8>    MCOʹ
//                <i> ĬϣʹܣPC4ϵͳʱ
//        <o9>    MCOʱԴѡ
//                <0=> HSI
//                <1=> PLLʱ
//                <2=> LSI
//                <3=> SYS_CLK
//                <i> ĬϵͳʱԴڲHSI
//        <o10>   MCOƵ
//                <0=> 1
//                <1=> 2
//                <2=> 4
//                <3=> 8
//                <4=> 16
*/

#define IOSC_24M_ENABLE               (1)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define EOSC_CLK_ENABLE               (0)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define FD_CLK_ENABLE                 (0)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define FD_CLK_SRC                    (0)     /*!< 0: IOCS_24M, 1: EOSC_CLK    2:IOSC_32K                               */
#define HCLK_SRC                      (0)     /*!< 0: IOCS_24M, 1: FD_CLK      2:IOSC_32K                  */
#define HCLK_DIV                      (0)     /*!< 0: DIV1,     1: DIV2,   2: DIV4,   3: DIV8,   4: DIV16,  5: DIV32    */
#define PCLK_DIV                      (0)     /*!< 0: DIV1,     1: DIV2,   2: DIV4,   3: DIV8,   4: DIV16,  5: DIV32    */
#define WAIT_STATE                    (1)     /*!< 0: 0 WS,     1: 1 WS                                   */
#define MCO_ENABLE                    (1)     /*!< 0: DISABLE,  1: ENABLE                                               */
#define MCO_SRCSEL                    (3)     
#define MCO_DIV                       (4)     /*!< 0: DIV1,     1: DIV2,   2: DIV4,   3: DIV8,   4: DIV16,  5: DIV32    */

/**
 * Initialize the system
 *
 * @param  none
 * @return none
 *
 * @brief  Setup the microcontroller system.
 *         Initialize the System.
 */
extern void Software_Delay(u32 timeBase10ms);
void SystemInit (void)
{
	RCC->MCOR = 3;

#if  ((HCLK_SRC == 0)||(HCLK_SRC == 1))
	RCC->CFGR = 0;
	RCC->PCR &= 0xFFFFFFFE;			//FD enable
	#if (IOSC_24M_ENABLE == 0)
		#error "System clock source issue,Inter 24M RC has not been enabled(Ѿѡڲ24RCʱΪϵͳʱԴڲ24RCʱδ)"
	#else
	RCC->HCR |= 0x01;			//inter 24mHZ enable
	#endif
	#if (FD_CLK_ENABLE == 1)
		# warning "Double Frequency is Enable,will Increase Power(˱Ƶģ飬δʹýICĵ)"
		RCC->PCR |= 0x01;
	#endif
#elif  (HCLK_SRC == 2)
	#if (FD_CLK_ENABLE == 0)
		#error "System clock source issue,Inter RC32K has not been enabled(Ѿѡ˱ƵʱΪϵͳʱԴǱƵģδ)"
	#else
		#if (FD_CLK_SRC == 0)
			#if (IOSC_24M_ENABLE == 0)
				#error "System clock source issue,Inter 24M RC has not been enabled(Ѿѡڲ24RCʱΪϵͳʱԴڲ24RCʱδ)"
			#else
				RCC->HCR |= 0x01;		//inter 24mHZ enable
				RCC->CFGR = 0;			//FD clocl source == 24mhz
				RCC->PCR = 0x01;			//FD enable  -- 
				RCC->CFGR |= 0x02;
			#endif
		#elif (FD_CLK_SRC == 1)
			RCC->CFGR |= 0x04;
			RCC->LCR |= 0x01;		//inter 24mHZ enable
			RCC->PCR = 0x01;			//FD enable  -- 
			RCC->CFGR |= 0x02;
			#if (IOSC_24M_ENABLE == 1)
				# warning "Internal 24M RC clock is Enable,will Increase Power(ڲ24ʱӣδʹýICĵ)"
				RCC->HCR |= 0x01;
			#else
				RCC->HCR = 0;		//inter 24mHZ disable
			#endif
		#endif
	#endif
#elif  (HCLK_SRC == 3)
	#if (FD_CLK_ENABLE == 1)
		# warning "Double Frequency is Enable,will Increase Power(˱Ƶģ飬δʹýICĵ)"
		RCC->PCR |= 0x01;
	#else
		RCC->PCR = 0x00;
	#endif
	#if (IOSC_24M_ENABLE == 1)
		# warning "Internal 24M clock is Enable,will Increase Power(ڲ24MICĵ)"
		RCC->HCR |= 0x01;
	#else
		RCC->HCR = 0;		//inter 24mHZ disable
	#endif
	RCC->CFGR |= 0x03;
#else
	#error "System clock source issue: System clock has not been enabled"
#endif
	
	IFMC ->CR= ((IFMC_CR_KEY_MAIN) | (WAIT_STATE << 5)) ; //wait state

	RCC->CFGR |= (HCLK_DIV << 4);
	RCC->CFGR |= (PCLK_DIV << 24);
  RCC->CFGR |= RCC_CFGR_WKSK;
  
#if (MCO_ENABLE == 1)
	AFIOC->AFS0 |= (1 << 16); //PC4
	RCC->MCOR = (MCO_DIV | (MCO_SRCSEL << 4) );

	#if (MCO_SRCSEL == 0) & (IOSC_24M_ENABLE == 0)
		# warning "MCO has no Clock Output(IOSC_24M is Not Enable)(ڲRC24ʱδMCO޲)"
	#elif (MCO_SRCSEL == 1) & (FD_CLK_ENABLE == 0)
		# warning "MCO has no Clock Output(Double Frequency is Not Enable)(ƵδMCO޲)"
	#endif
#endif

}

/**
  * @}
  */
